#ifndef __REVERSE_EXTENSION__
#define __REVERSE_EXTENSION__

#ifndef FUNCTIONS
#error You must define a list of functions.
#endif

#define SETTING(NAME, ...) \
  ParentMix::_call_##NAME = call_##NAME; \

#define FUNCTION(NAME, ...) \
public: \
  template<class ...Args> \
  int NAME(Args &&...args) \
  { \
    return _call_##NAME(this, true, std::forward<Args>(args)...); \
  } \
protected: \
  typedef int _type_##NAME(Me *, bool, ##__VA_ARGS__); \
  _type_##NAME *_call_##NAME = NULL; \
  template<class ...Args> \
  static int call_##NAME(ParentMix *parent, bool forward, Args ...args) \
  { \
    if (forward) \
      return (*((Me *)parent)->_call_##NAME)((Me *)parent, false, std::forward<Args>(args)...); \
    return ((Parent *)parent)->NAME(std::forward<Args>(args)...); \
  } \

#include <functional>

template <template <class Base> class ... Bases>
class Mix;

template <template <class Base> class Ext, template <class Base> class ... Bases>
class Mix<Ext, Bases...>: public Ext<Mix<Bases...> >
{
  typedef Mix<Ext, Bases...> Me;
  typedef Mix<Bases...> ParentMix;
  typedef Ext<ParentMix> Parent;
public:
  template<class ... Args>
  Mix(Args &&...args)
    : Parent(std::forward<Args>(args)...)
  {
    FUNCTIONS(SETTING)
    puts("Mix<Ext, Bases...>::Mix");
  }
  virtual ~Mix()
  {
    puts("Mix<Ext, Bases...>::~Mix");
  }
  FUNCTIONS(FUNCTION)
};

#undef FUNCTION
#undef SETTING

#define FUNCTION(NAME, ...) \
public: \
  template<class ...Args> \
  int NAME(Args &&...args) \
  { \
    return _call_##NAME(this, true, std::forward<Args>(args)...); \
  } \
protected: \
  typedef int _type_##NAME(Me *, bool, ##__VA_ARGS__); \
  _type_##NAME *_call_##NAME = NULL; \


template <>
class Mix<>
{
  typedef Mix<> Me;
public:
  Mix()
  {
    puts("Mix<>::Mix");
  }
  virtual ~Mix()
  {
    puts("Mix<>::~Mix");
  }
  FUNCTIONS(FUNCTION)
};

#undef FUNCTION

#endif //__REVERSE_EXTENSION__
